Index: issm/trunk/src/c/objects/Elements/Penta.cpp
===================================================================
--- issm/trunk/src/c/objects/Elements/Penta.cpp	(revision 5662)
+++ issm/trunk/src/c/objects/Elements/Penta.cpp	(revision 5663)
@@ -20,5 +20,10 @@
 
 /*Element macros*/
-#define NUMVERTICES 6
+#define NUMVERTICES   6
+#define NUMVERTICES2D 3
+#define NDOF1 1
+#define NDOF2 2
+#define NDOF3 3
+#define NDOF4 4
 
 /*Penta constructors and destructor*/
@@ -2302,5 +2307,4 @@
 	/*Collapsed formulation: */
 	int       i;
-	const int NDOF2=2;
 	const int numdofs=NDOF2*NUMVERTICES;
 	int*      doflist=NULL;
@@ -2386,8 +2390,6 @@
 
 	/* node data: */
-	const int    NUMVERTICES3d=6;
-	const int    NUMVERTICES2d=3;
-	const int    numdof2d=2*NUMVERTICES2d;
-	double       xyz_list[NUMVERTICES3d][3];
+	const int    numdof2d=2*NUMVERTICES2D;
+	double       xyz_list[NUMVERTICES][3];
 	int*         doflist=NULL;
 
@@ -2497,5 +2499,5 @@
 
 		/* Get node coordinates and dof list: */
-		GetVerticesCoordinates(&xyz_list[0][0], nodes, NUMVERTICES3d);
+		GetVerticesCoordinates(&xyz_list[0][0], nodes,NUMVERTICES);
 		tria->GetDofList(&doflist,MacAyealApproximationEnum);  //Pattyn dof list
 
@@ -2715,10 +2717,8 @@
 
 	int i,j;
-	const int DOFPERGRID=4;
-	const int numdof=NUMVERTICES*DOFPERGRID;
+	const int numdof=NUMVERTICES*NDOF4;
 	int*      doflist=NULL;
 
-	const int NUMVERTICES2d=3;
-	const int numdof2d=NUMVERTICES2d*DOFPERGRID;
+	const int numdof2d=NUMVERTICES2D*NDOF4;
 
 	/*Collapsed formulation: */
@@ -2727,5 +2727,5 @@
 	/*Grid data: */
 	double     xyz_list[NUMVERTICES][3];
-	double	  xyz_list_tria[NUMVERTICES2d][3];
+	double	  xyz_list_tria[NUMVERTICES2D][3];
 	double	  bed_normal[3];
 
@@ -2872,5 +2872,5 @@
 		friction=new Friction("3d",inputs,matpar,analysis_type);
 
-		for(i=0;i<NUMVERTICES2d;i++){
+		for(i=0;i<NUMVERTICES2D;i++){
 			for(j=0;j<3;j++){
 				xyz_list_tria[i][j]=xyz_list[i][j];
@@ -2970,5 +2970,4 @@
 
 	/* node data: */
-	const int    NDOF1=1;
 	const int    numdof=NDOF1*NUMVERTICES;
 	double       xyz_list[NUMVERTICES][3];
@@ -3148,5 +3147,4 @@
 
 	/* node data: */
-	const int    NDOF1=1;
 	const int    numdof=NDOF1*NUMVERTICES;
 	double       xyz_list[NUMVERTICES][3];
@@ -3480,5 +3478,4 @@
 	int i,j,k;
 	
-	const int NDOF2=2;
 	const int numdofs=NDOF2*NUMVERTICES;
 	int*      doflist=NULL;
@@ -3667,5 +3664,4 @@
 
 	/* node data: */
-	const int    NDOF2=2;
 	const int    numdof=NDOF2*NUMVERTICES;
 	double       xyz_list[NUMVERTICES][3];
@@ -3756,9 +3752,6 @@
 	/*indexing: */
 	int i,j;
-
-	const int DOFPERGRID=4;
-	const int numdof=NUMVERTICES*DOFPERGRID;
-	const int NUMVERTICES2d=3;
-	int       numdof2d=NUMVERTICES2d*DOFPERGRID;
+	const int numdof=NUMVERTICES*NDOF4;
+	int       numdof2d=NUMVERTICES2D*NDOF4;
 	int*      doflist=NULL;
 
@@ -3767,5 +3760,5 @@
 
 	/*parameters: */
-	double		   xyz_list_tria[NUMVERTICES2d][3];
+	double		   xyz_list_tria[NUMVERTICES2D][3];
 	double         xyz_list[NUMVERTICES][3];
 	double		   bed_normal[3];
@@ -3889,5 +3882,5 @@
 			/* Build gaussian vector */
 			for(i=0;i<NUMVERTICES+1;i++){
-				Pe_gaussian[i*DOFPERGRID+2]=-rho_ice*gravity*Jdet*gauss_weight*l1l7[i];
+				Pe_gaussian[i*NDOF4+2]=-rho_ice*gravity*Jdet*gauss_weight*l1l7[i];
 			}
 
@@ -3934,5 +3927,5 @@
 	if ( (onbed==1) && (shelf==1)){
 
-		for(i=0;i<NUMVERTICES2d;i++){
+		for(i=0;i<NUMVERTICES2D;i++){
 			for(j=0;j<3;j++){
 				xyz_list_tria[i][j]=xyz_list[i][j];
@@ -3970,7 +3963,7 @@
 			BedNormal(&bed_normal[0],xyz_list_tria);
 
-			for(i=0;i<NUMVERTICES2d;i++){
+			for(i=0;i<NUMVERTICES2D;i++){
 				for(j=0;j<3;j++){
-					Pe_temp[i*DOFPERGRID+j]+=water_pressure*gauss_weight*Jdet2d*L[i]*bed_normal[j];
+					Pe_temp[i*NDOF4+j]+=water_pressure*gauss_weight*Jdet2d*L[i]*bed_normal[j];
 				}
 			}
@@ -4025,5 +4018,4 @@
 
 	/* node data: */
-	const int    NDOF1=1;
 	const int    numdof=NDOF1*NUMVERTICES;
 	double       xyz_list[NUMVERTICES][3];
@@ -4189,5 +4181,4 @@
 	int found=0;
 
-	const int  NDOF1=1;
 	const int  numdof=NUMVERTICES*NDOF1;
 	int*       doflist=NULL;
@@ -5267,8 +5258,7 @@
 	int i;
 
-	const int    NUMVERTICES2d=3;
 	const int    numdofpervertex=2;
 	const int    numdof=numdofpervertex*NUMVERTICES;
-	const int    numdof2d=numdofpervertex*NUMVERTICES2d;
+	const int    numdof2d=numdofpervertex*NUMVERTICES2D;
 	int*         doflistp=NULL;
 	int*         doflistm=NULL;
Index: issm/trunk/src/c/objects/Elements/Tria.cpp
===================================================================
--- issm/trunk/src/c/objects/Elements/Tria.cpp	(revision 5662)
+++ issm/trunk/src/c/objects/Elements/Tria.cpp	(revision 5663)
@@ -21,4 +21,8 @@
 /*Element macros*/
 #define NUMVERTICES 3
+#define NDOF1 1
+#define NDOF2 2
+#define NDOF3 3
+#define NDOF4 4
 
 /*Tria constructors and destructor*/
@@ -628,5 +632,4 @@
 
 	/*constants: */
-	const int    NDOF2=2;
 	const int    numdof=NDOF2*NUMVERTICES;
 
@@ -899,7 +902,4 @@
 void  Tria::GradjB(Vec gradient){
 
-	/* constants*/
-	const int    NDOF2=2;
-
 	/*Intermediaries*/
 	int        i,ig;
@@ -978,5 +978,4 @@
 
 	/* node data: */
-	const int    NDOF2=2;
 	double       xyz_list[NUMVERTICES][3];
 	int          doflist1[NUMVERTICES];
@@ -1603,5 +1602,4 @@
 	/* node data: */
 	const int    numdof=2*NUMVERTICES;
-	const int    NDOF2=2;
 	double       xyz_list[NUMVERTICES][3];
 
@@ -1705,5 +1703,4 @@
 	/* node data: */
 	const int    numdof=2*NUMVERTICES;
-	const int    NDOF2=2;
 	double       xyz_list[NUMVERTICES][3];
 
@@ -1816,5 +1813,4 @@
 	/* node data: */
 	const int    numdof=2*NUMVERTICES;
-	const int    NDOF2=2;
 	double       xyz_list[NUMVERTICES][3];
 
@@ -1924,5 +1920,4 @@
 	/* node data: */
 	const int    numdof=2*NUMVERTICES;
-	const int    NDOF2=2;
 	double       xyz_list[NUMVERTICES][3];
 
@@ -2035,5 +2030,4 @@
 	/* node data: */
 	const int    numdof=2*NUMVERTICES;
-	const int    NDOF2=2;
 	double       xyz_list[NUMVERTICES][3];
 
@@ -2475,5 +2469,4 @@
 
 	/* node data: */
-	const int    NDOF1=1;
 	const int    numdof=NDOF1*NUMVERTICES;
 	double       xyz_list[NUMVERTICES][3];
@@ -2630,5 +2623,4 @@
 
 	/* node data: */
-	const int    NDOF1=1;
 	const int    numdof=NDOF1*NUMVERTICES;
 	double       xyz_list[NUMVERTICES][3];
@@ -2718,5 +2710,4 @@
 
 	/* node data: */
-	const int    NDOF1=1;
 	const int    numdof=NDOF1*NUMVERTICES;
 	double       xyz_list[NUMVERTICES][3];
@@ -3378,5 +3369,4 @@
 	int    i;
 	int    connectivity;
-	const int NDOF2=2;
 	const int numdofs=NUMVERTICES*NDOF2;
 	int*         doflist=NULL;
@@ -3414,5 +3404,4 @@
 
 	/* node data: */
-	const int    NDOF1=1;
 	const int    numdof=NDOF1*NUMVERTICES;
 	double       xyz_list[NUMVERTICES][3];
@@ -3516,5 +3505,4 @@
 	int i,j;
 
-	const int  NDOF1=1;
 	const int  numdof=NUMVERTICES*NDOF1;
 	int*       doflist=NULL;
@@ -3587,5 +3575,4 @@
 
 	/* node data: */
-	const int    NDOF1=1;
 	const int    numdof=NDOF1*NUMVERTICES;
 	double       xyz_list[NUMVERTICES][3];
@@ -3756,5 +3743,4 @@
 
 	/* node data: */
-	const int    NDOF1=1;
 	const int    numdof=NDOF1*NUMVERTICES;
 	double       xyz_list[NUMVERTICES][3];
@@ -3865,5 +3851,4 @@
 	/*constants: */
 	const int    numnodes=3;
-	const int    NDOF1=1;
 	const int    numdof=NDOF1*numnodes;
 
@@ -3915,5 +3900,4 @@
 	
 	/* node data: */
-	const int    NDOF1=1;
 	const int    numdof=NDOF1*NUMVERTICES;
 	double       xyz_list[NUMVERTICES][3];
@@ -3999,5 +3983,4 @@
 
 	/* node data: */
-	const int    NDOF1=1;
 	const int    numdof=NDOF1*NUMVERTICES;
 	double       xyz_list[NUMVERTICES][3];
@@ -4070,5 +4053,4 @@
 
 	/* node data: */
-	const int    NDOF1=1;
 	const int    numdof=NDOF1*NUMVERTICES;
 	double       xyz_list[NUMVERTICES][3];
@@ -4141,5 +4123,4 @@
 
 	/* node data: */
-	const int    NDOF1=1;
 	const int    numdof=NDOF1*NUMVERTICES;
 	double       xyz_list[NUMVERTICES][3];
@@ -4207,5 +4188,4 @@
 
 	/* node data: */
-	const int    NDOF1=1;
 	const int    numdof=NDOF1*NUMVERTICES;
 	double       xyz_list[NUMVERTICES][3];
@@ -4301,5 +4281,4 @@
 	/* node data: */
 	const int    numdof=2*NUMVERTICES;
-	const int    NDOF2=2;
 	double       xyz_list[NUMVERTICES][3];
 	int*         doflist=NULL;
@@ -4499,5 +4478,4 @@
 	/* node data: */
 	const int    numdof=2*NUMVERTICES;
-	const int    NDOF2=2;
 	double       xyz_list[NUMVERTICES][3];
 	int*         doflist=NULL;
@@ -4720,5 +4698,4 @@
 
 	/* node data: */
-	const int    NDOF4=4;
 	const int    numdof=NDOF4*NUMVERTICES;
 	double       xyz_list[NUMVERTICES][3];
@@ -4936,5 +4913,4 @@
 	/*Collapsed formulation: */
 	int       i;
-	const int NDOF2=2;
 	const int numdofs=NDOF2*NUMVERTICES;
 	int*         doflist=NULL;
@@ -5012,5 +4988,4 @@
 
 	/* node data: */
-	const int    NDOF1=1;
 	const int    numdof=NDOF1*NUMVERTICES;
 	double       xyz_list[NUMVERTICES][3];
@@ -5088,5 +5063,4 @@
 
 	/* node data: */
-	const int    NDOF1=1;
 	const int    numdof=NDOF1*NUMVERTICES;
 	double       xyz_list[NUMVERTICES][3];
@@ -5160,5 +5134,4 @@
 
 	/* node data: */
-	const int    NDOF1=1;
 	const int    numdof=NDOF1*NUMVERTICES;
 	double       xyz_list[NUMVERTICES][3];
@@ -5239,5 +5212,4 @@
 	int i,found;
 	
-	const int  NDOF1=1;
 	const int  numdof=NUMVERTICES*NDOF1;
 	int*         doflist=NULL;
@@ -5332,5 +5304,4 @@
 	int i,found;
 	
-	const int  NDOF1=1;
 	const int  numdof=NUMVERTICES*NDOF1;
 	int*       doflist=NULL;
@@ -5880,5 +5851,4 @@
 
 	/* node data: */
-	const int    NDOF2=2;
 	double       xyz_list[NUMVERTICES][3];
 	int          doflist1[NUMVERTICES];